<template>
  <q-layout view="hhh lPr fff">
    <q-header class="bg-white">
      <q-toolbar
        style="height: 56px; background-color: #f5eeff"
        v-if="displaySearchBar"
      >
        <div class="column items-center">
          <q-btn
            id="header-search-button"
            round
            dense
            color="white"
            class="col"
            @click="menu = !menu"
          >
            <q-img
              :src="
                searchEngines.find((se) => se.id === this.currentSearchEngine)
                  .avatar
              "
            ></q-img>
            <q-menu :offset="[18, 10]" auto-close class="shadow-24">
              <q-list style="min-width: 100px">
                <q-item
                  clickable
                  v-for="se in searchEngines"
                  :key="se.id"
                  @click="setSearchEngine(se.id)"
                >
                  <q-item-section avatar>
                    <q-img :src="se.avatar"></q-img>
                  </q-item-section>
                  <q-item-section>{{ se.name }}</q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </q-btn>
          <img
            src="/imgs/down-arrow.svg"
            height="5px"
            class="col menu-indicator"
            :class="menu ? 'menu' : ''"
          />
        </div>
        <q-input
          :placeholder="searchPlaceholder"
          ref="search"
          bg-color="white"
          color
          grow
          dense
          rounded
          outlined
          clearable
          clear-icon="img:imgs/bx-x-circle.svg"
          type="search"
          standout
          :value="currentSearchTerm"
          @input="setCurrentSearchTerm"
          class="lh-searchbar"
          @keyup.enter="doSearch"
        ></q-input>
        <q-btn flat round dense to="/app/history" class="no-right-margin">
          <q-avatar size="32px">
            <img src="/imgs/history.svg" alt="History icon" />
          </q-avatar>
        </q-btn>
        <q-btn
          outline
          round
          dense
          color="transparent"
          class="q-mx-md"
          size="md"
        >
          <q-avatar size="32px">
            <q-img
              :src="userAvatar"
              transition="flip-down"
              spinner-color="accent"
            ></q-img>
          </q-avatar>
          <q-menu :offset="[18, 10]" auto-close class="shadow-24">
            <q-list>
              <q-item>
                <q-item-section class="text-black">
                  {{ userName }}
                </q-item-section>
              </q-item>
              <q-item clickable @click="signOut">
                <q-item-section avatar>
                  <img src="/imgs/sign-out.svg" alt="Sign out icon" />
                </q-item-section>
                <q-item-section>Sign out</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>
      </q-toolbar>
    </q-header>
    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { mapActions, mapGetters, mapState } from "vuex";
// import { userSession } from "boot/blockstack";

export default {
  name: "MyLayout",
  data() {
    return {
      currentSearchEngine: 0,
      menu: false,
    };
  },
  computed: {
    ...mapState("user", ["user"]),
    ...mapGetters({
      searchEngines: "search/searchEngines",
      search: "search/search",
      initialSearchComplete: "search/initialSearchComplete",
      currentSearchTerm: "search/currentSearchTerm",
    }),
    userAvatar() {
      let avatar = "/imgs/avatarrghh.svg";
      if (this.user.profile.hasOwnProperty("image")) {
        avatar = this.user.profile.image[0].contentUrl;
      }
      return avatar;
    },
    userName() {
      if (this.user.profile.hasOwnProperty("name")) {
        return this.user.profile.name;
      } else if (this.user.hasOwnProperty("username")) {
        return this.user.username.substring(
          0,
          this.user.username.indexOf(".id")
        );
      } else {
        return this.user.identityAddress;
      }
    },
    displaySearchBar() {
      return this.initialSearchComplete || this.$route.path === "/app/history";
    },
    searchPlaceholder() {
      return `Search ${
        this.searchEngines.find((se) => se.id === this.currentSearchEngine).name
      }`;
    },
  },
  watch: {
    searchTerm() {
      if (!this.searchTerm) {
        this.resetSearch();
      }
    },
  },
  mounted() {
    if (process.env.DEV) console.log("q: ", this.q$);
  },
  beforeUpdate() {
    if (this.search.searchTerm) {
      this.searchTerm = this.search.searchTerm;
    }
  },
  methods: {
    ...mapActions({
      addSearch: "search/addSearch",
      clearSearch: "search/clearSearch",
      setSearchTerm: "search/setSearchTerm",
    }),
    setCurrentSearchTerm(e) {
      if (e) {
        this.setSearchTerm(e);
        if (e.keyCode === 13) {
          this.doSearch();
        }
      } else {
        this.setSearchTerm("");
      }
    },
    setSearchEngine(param) {
      this.currentSearchEngine = param;
      if (this.searchTerm) {
        this.doSearch();
      }
    },
    signOut() {
      this.$userSession.signUserOut();
      this.$router.push("/");
    },
    doSearch() {
      if (this.searchTerm === null) {
        this.resetSearch();
      } else {
        if (this.$router.page !== "app") {
          this.$router.push("/app/search");
        }
        this.addSearch({
          timestamp: Date.now(),
          src: this.searchEngines.find(
            (se) => se.id === this.currentSearchEngine
          ),
          searchTerm: this.currentSearchTerm,
        });
      }
    },
    resetSearch() {
      this.clearSearch();
      this.$nextTick(function () {
        if (this.$router.page !== "app") {
          this.$router.push("/app/search");
        }
        if (process.env.DEV)
          console.log("search bar: ", this.$refs.searchBarString);
      });
    },
    // this.addSearch({
    //   timestamp: Date.now(),
    //   src: this.searchEngines.find(se => se.id === this.currentSearchEngine),
    //   searchTerm: ""
    // });
  },
};
</script>

<style scoped>
.lh-searchbar {
  width: 100%;
  margin-left: 8px;
  margin-right: 24px;
  border-radius: 100px;
  box-shadow: 0 8px 16px -8px rgba(120, 93, 153, 0.2);
}
.hat {
  margin-right: 16px;
}
.menu-indicator {
  margin-top: 3px;
  margin-right: 4px;
}

@media only screen and (max-width: 425px) {
  .q-toolbar {
    padding-right: 0px;
    padding-left: 0px;
  }
  .q-btn {
    margin-left: 8px;
    margin-right: 8px;
  }
  .lh-searchbar {
    margin-left: 0px;
    margin-right: 0px;
  }
  .no-right-margin {
    margin-right: 0px;
  }
  .menu-indicator {
    margin-right: 4px;
  }
}
img {
  transition: transform 0.2s;
}
img.menu {
  transform: rotate(-180deg);
}
</style>
